/**
* Carlos O. Rios (gth700w)
* Collaboration Statement: I worked on the homework assignment alone, using only course materials.
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;

/**
* Summary: This method creates the the buttons, labels, and text for the JFrame.
* An action listener is also created in response to the choice (rock, paper, or scissors) the player picks.
*
* @author Carlos O. Rios (gth700w)
* @version 1.0
*/

public class RpsPanel extends JPanel
{
	//Creating variables for the JButtons, JLabels, and Text.
	private JButton rock, paper, scissors;
	private JLabel resultDisplay;
	private JPanel buttonPanel;
	private JTextField display;
	//Making the round private so that it applies to once round at a time.
	private Round round;

	public RpsPanel()
	{
		//Creating JButtons for the three choices.
		rock = new JButton("Rock");
		paper = new JButton("Paper");
		scissors = new JButton("Scissors");
		//This is the default text of the result display.
		resultDisplay = new JLabel("-----");

		//Making a button listener for the three JButtons
		ButtonListener listener = new ButtonListener();

		//Adding the three JButtons to the new listener
		rock.addActionListener (listener);
		paper.addActionListener (listener);
		scissors.addActionListener (listener);

		//Making the panel within the JFrame to throw in the buttons and display result.
		buttonPanel = new JPanel();
		buttonPanel.setPreferredSize (new Dimension(340, 75));
		buttonPanel.setBackground (Color.white);
		//Throwing the buttons into the newly created JPanel.
		buttonPanel.add (rock);
		buttonPanel.add (paper);
		buttonPanel.add (scissors);
		//Throwing the result display text area in the the newly created JPanel
		add (resultDisplay);

		//Making the height and width, and background color of the JFrame.
		setPreferredSize (new Dimension(350, 120));
		setBackground (Color.white);

		//Adding the entire JPanel (buttons and display text now included) into the JFrame.
		add (buttonPanel);
	}

	private void update(Round round)
	{
		//Grabs whatever choices the player and computer made, as well as the win, tie, or lose text declaration and makes them strings
		String playerResult = round.getPlayerChoice();
		String computerResult = round.getComputerChoice();
		String matchResult = round.outcome();

		//This set a text in the resultDisplay JLabel with a string that includes the string player/computer choices and result into it.
		resultDisplay.setText("You picked "+playerResult+", the computer picked "+computerResult+". "+matchResult+".");

	}

	private String randomChoice()
	{

		//Creating a new Random for the computer, since it will randomly choose one of the three choices.
		Random rand = new Random();
		//Making a string variable so that the choice that is picked can be returned and used in the conditionals to compare
		// the player's choice.
		String result;
		int computerChoice;
		//Making the choice an int at first, so that the new random picks an integer which will represent a choice.
		computerChoice = rand.nextInt(3);
		//Making the conditionals for the randomly selected integer numbers
		//Rock is chosen if Zero is randomly taken.
		if ((computerChoice == 0))
		{
			result = "Rock";
		}
		//Paper is chosen if One is randomly taken
		else
		{	
			if ((computerChoice == 1))
			{
				result = "Paper";
			}
			else
			//Since the random can only choose 0, 1 or 2, I just made "else" (2) be Scissors
			{
				result = "Scissors";
			}
		}
		//Returning the string result		
		return result;
	}

	//Making the JButtons use ActionListening so that whatever choice the player makes, can be thrown into the conditionals
	// thus be compared to the computer's random choice, leading to a result to be displayed in resultDisplay
	private class ButtonListener implements ActionListener
	{

		public void actionPerformed (ActionEvent event)
		{
			String playerChoice;
			
			//If the JButton "rock" is chosen, the playerChoice string variable will be "Rock"
			if (event.getSource()== rock)
				playerChoice = "Rock";
			else
			{
				//If the JButton "paper" is chosen, the playerChoice string variable will be "Paper"
				if (event.getSource()== paper)
					playerChoice = "Paper";

				//Since the JButton "scissors" is the only thing left, it is thrown into "else"
				else
				{
					playerChoice = "Scissors";
				}
				
			}
		//Making a new round based on the the choices given
		round = new Round(playerChoice, randomChoice());
		//The round is updated everytime another button is clicked by the player
		update(round);

		}
	}
}